(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define("react-use-click-away", ["React"], factory);
	else if(typeof exports === 'object')
		exports["react-use-click-away"] = factory(require("react"));
	else
		root["react-use-click-away"] = factory(root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE__0__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/lib/";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__0__;

/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return useClickAway; });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(0);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);

/**
 * Registers a click listener to the document to help you click away to close dropdowns/containers
 * @module react-use-click-away
 * @param {object} options - The options object expects the following properties
 * @property {string} reactAppId - the id of the react app (i.e. 'root')
 * @property {array} clickable - an array of element ids which can be clicked which won't close the menus/containers
 **/

function useClickAway() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      reactAppId = _ref.reactAppId,
      clickable = _ref.clickable,
      open = _ref.open,
      setOpen = _ref.setOpen;

  // Check for the expected props
  if (Object.keys(arguments[0]).length < 4) {
    var expectedProps = ['open', 'setOpen', 'reactAppId', 'clickable']; // Check for all props

    for (var _i = 0, _expectedProps = expectedProps; _i < _expectedProps.length; _i++) {
      var prop = _expectedProps[_i];

      if (!arguments[0].hasOwnProperty(prop)) {
        console.error("The options object is missing the ".concat(prop, " property."));
        return;
      }
    }
  } // Check the clickable prop


  if (!clickable || clickable.length < 1) {
    throw Error('`clickable` property must contain at least one element id. Try passing an array of element ids to useClickAway({ clickable: [\'element1\', \'element2\'] })');
  } // Check for # symbol


  if (reactAppId.includes('#')) {
    console.error('`reactAppId` should not be prefixed with a `#` symbol.'); // Return so the error doesn't cause the app to crash for the user

    return;
  }

  if (clickable.some(function (e) {
    return e.includes('#');
  })) console.error('Element ids in `clickable` array should not be prefixed with a `#` symbol.');

  function handleClick(e) {
    if (e && (e.path || e.composedPath())) {
      // Chrome uses e.path while Firefox uses e.composedPath
      var path = e.path || e.composedPath(); // e.path returns an array of the elements in the path of the click

      for (var i = 0; i < path.length; i++) {
        // If the elements within the click path have any clickable elements, then let the click event continue
        if (clickable.includes(path[i].id)) {
          return;
        }
      }
    } // Otherwise, the was outisde the dropdown then close the dropdown


    setOpen(false);
  }

  Object(react__WEBPACK_IMPORTED_MODULE_0__["useEffect"])(function () {
    // Check to make sure document is defined
    if (document) {
      // Grab the main container for the app
      var mainContainer = document.querySelector("#".concat(reactAppId)); // Make sure mainContainer is defined, or it throws an error in the test

      if (mainContainer) {
        open ? mainContainer.addEventListener('click', handleClick, false) : mainContainer.removeEventListener('click', handleClick, false);
      }
    }

    return function () {
      document.querySelector("#".concat(reactAppId)).removeEventListener('click', handleClick, false);
    };
  }, [open]);
}

/***/ })
/******/ ]);
});